{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2019                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}
unit WEBLib.GoogleReCaptcha;

interface

uses
  {$IFNDEF LCLTMSWEB}
  System.Classes, System.SysUtils, Vcl.Controls, Vcl.Graphics,
  Types, WEBLib.Controls;
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  Classes, SysUtils, Controls, Graphics, Types, WEBLib.Controls;
  {$ENDIF}

type
  TVerifyEventArgs = class(TPersistent)
  private
    FScore: Double;
    FAction: string;
    FDateTime: TDateTime;
    FHostName: string;
  public
    property Action: string read FAction write FAction;
    property Score: Double read FScore write FScore;
    property TimeStamp: TDateTime read FDateTime write FDateTime;
    property HostName: string read FHostName write FHostName;
  end;

  TVerifyEvent = procedure(Sender: TObject; Args: TVerifyEventArgs) of object;

  {$IFNDEF LCLTMSWEB}
  [ComponentPlatforms(TMSWebPlatform)]
  {$ENDIF}
  TWebGoogleReCaptcha = class(TWebCustomControl)
  private
    FAPIKey: string;
    FOnVerified: TVerifyEvent;
    FAPIUrl: string;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Verify(AAction: string);
  published
    property ElementClassName;
    property ElementID;
    property Enabled;
    property APIKey: string read FAPIKey write FAPIKey;
    property APIUrl: string read FAPIUrl write FAPIUrl;
    property OnVerified: TVerifyEvent read FOnVerified write FOnVerified;
  end;


implementation

{ TWebGoogleReCaptcha }

constructor TWebGoogleReCaptcha.Create(AOwner: TComponent);
begin
  inherited;
  Width := 190;
  Height := 40;
end;

destructor TWebGoogleReCaptcha.Destroy;
begin
  inherited;
end;

procedure TWebGoogleReCaptcha.Verify(AAction: string);
begin
//
end;

end.
