{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit libsentry;

interface

uses
  JS, Web, JSDelphiSystem;

type
  TBeforeSendHint = class(TJSObject)
    originalException: TJSObject; 
  end;

  TBeforeSendEventExceptionMechanism = class(TJSObject)
    synthetic: Boolean;
  end;

  TBeforeSendEventExceptionStackTrace = class(TJSObject)
    frames: TJSArray;
  end;

  TBeforeSendEventExceptionValue = class(TJSObject)
    value: String; 
    mechanism: TBeforeSendEventExceptionMechanism; 
    stacktrace: TBeforeSendEventExceptionStackTrace; 
  end;

  TBeforeSendEventException = class(TJSObject)
    values: TJSArray; 
  end;

  TBeforeSendEvent = class(TJSObject)
    // The following may not be present
    stacktrace: TBeforeSendEventExceptionStackTrace;
    exception: TBeforeSendEventException;
  end;

  TJSSentryScope = class(TJSObject)
    procedure setTag(aLey: String; aValue: String);
    procedure setUser(user: TJSObject);
  end;

  TJSSentryScopeCallback = reference to Procedure(scope: TJSSentryScope);

  TJSSentry = class(TJSObject)
  public
    class procedure init(options: TJSObject);
    class procedure captureException(anObj: TJSObject); overload;
    class procedure captureException(anObj: TJSObject; extraData: TJSObject); overload;
    class procedure captureMessage(aMsg: String);
    class procedure configureScope(scopeCallback: TJSSentryScopeCallback);
    class procedure addBreadcrumb(params: TJSObject);
  end;

implementation

procedure TJSSentryScope.setTag(aLey: String; aValue: String);
begin
end;

procedure TJSSentryScope.setUser(user: TJSObject);
begin
end;

class procedure TJSSentry.init(options: TJSObject);
begin
end;

class procedure TJSSentry.captureException(anObj: TJSObject);
begin
end;

class procedure TJSSentry.captureException(anObj: TJSObject; extraData: TJSObject);
begin
end;

class procedure TJSSentry.captureMessage(aMsg: String);
begin
end;

class procedure TJSSentry.configureScope(scopeCallback: TJSSentryScopeCallback);
begin
end;

class procedure TJSSentry.addBreadcrumb(params: TJSObject);
begin
end;

end.
