{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Calendar;

interface

uses
  Classes, Web, JS, WEBLib.Controls, libcalendar;

type
  TCalendarInactiveDays = class(TPersistent)
  protected
    procedure Changed;
  public
    constructor Create; virtual;
    property OnChanged: TNotifyEvent read FOnChanged write FOnChanged;
  published
    property Sunday: Boolean read FSunday write SetSunday;
    property Monday: Boolean read FMonday write SetMonday;
    property Tuesday: Boolean read FTuesday write SetTuesDay;
    property Wednesday: Boolean read FWednesday write SetWednesday;
    property Thursday: Boolean read FThursday write SetThursday;
    property Friday: Boolean read FFriday write SetFriday;
    property Saturday: Boolean read FSaturday write SetSaturday;
  end;

  TCalendarWeekDayNames = class(TPersistent)
  protected
    procedure Changed;
  public
    constructor Create; virtual;
    property OnChanged: TNotifyEvent read FOnChanged write FOnChanged;
  published
    property Sunday: string read FSunday write SetSunday;
    property Monday: string read FMonday write SetMonday;
    property Tuesday: string read FTuesday write SetTuesDay;
    property Wednesday: string read FWednesday write SetWednesday;
    property Thursday: string read FThursday write SetThursday;
    property Friday: string read FFriday write SetFriday;
    property Saturday: string read FSaturday write SetSaturday;
  end;

  TCalendarMonthNames = class(TPersistent)
  protected
    procedure Changed;
  public
    constructor Create; virtual;
    property OnChanged: TNotifyEvent read FOnChanged write FOnChanged;
  published
    property January: string read FJanuary write SetJanuary;
    property February: string read FFebruary write SetFebruary;
    property March: string read FMarch write SetMarch;
    property April: string read FApril write SetApril;
    property May: string read FMay write SetMay;
    property June: string read FJune write SetJune;
    property July: string read FJuly write SetJuly;
    property August: string read FAugust write SetAugust;
    property September: string read FSeptember write SetSeptember;
    property October: string read FOctober write SetOctober;
    property November: string read FNovember write SetNovember;
    property December: string read FDecember write SetDecember;
  end;

  TCalendarSelectDateEvent = procedure(Sender: TObject; ADate: TDateTime) of object;
  TCalendarDates = array of TDateTime;

  TCalendar = class(TCustomControl)
  protected
    procedure SetElementClassName(AValue: string); override;

    function CreateElement: TJSElement; override;
    function GetNameOfDaysArray: TJSArray;
    function GetMonthNamesArray: TJSArray;
    function GetEnabledDaysArray: TJSArray;
    function GetID: string; override;
    procedure InactiveDaysChanged(Sender: TObject);
    procedure NameOfDaysChanged(Sender: TObject);
    procedure MonthNamesChanged(Sender: TObject);
    procedure HandleDateSelect(Data: TJSDate);
    procedure HandleDateUnselect(Data: TJSDate);
  public
    destructor Destroy; override;
    procedure CreateInitialize; override;
    procedure EndUpdate; override;
    function SelectedDates: TCalendarDates;
  published
    property Align;
    property Anchors;
    property ChildOrder;
    property DragMode;
    property ShowHint;
    property Visible;
    property TabOrder;
    property TabStop;
    property ElementSelectedDateClassName: TElementClassName read FElementSelectedDateClassName write SetElementSelectedDateClassName;
    property ElementCurrentDateClassName: TElementClassName read FElementCurrentDateClassName write SetElementCurrentDateClassName;
    property ElementBackgroundClassName: TElementClassName read FElementBackgroundClassName write SetElementBackgroundClassName;
    property ElementDayNamesClassName: TElementClassName read FElementDayNamesClassName write SetElementDayNamesClassName;
    property ElementHeaderClassName: TElementClassName read FElementHeaderClassName write SetElementHeaderClassName;
    property SelectedDate: TDateTime read GetSelectedDate write SetSelectedDate;
    property Year: Integer read GetYear write SetYear;
    property Month: Integer read GetMonth write SetMonth;
    property Day: Integer read GetDay write SetDay;
    property Font;
    property HintNext: string read FHintNext write SetHintNext;
    property HintPrev: string read FHintPrev write SetHintPrev;
    property MaxDate: TDateTime read FMaxDate write SetMaxDate;
    property MinDate: TDateTime read FMinDate write SetMinDate;
    property MultiSelect: Boolean read FMultiSelect write SetMultiSelect;
    property FirstDay: Integer read FFirstDay write SetFirstDay;
    property EnablePastDates: Boolean read FEnablePastDates write SetEnablePastDates;
    property InactiveDays: TCalendarInactiveDays read FInactiveDays write SetInactiveDays;
    property NameOfMonths: TCalendarMonthNames read FMonthNames write SetMonthNames;
    property NameOfDays: TCalendarWeekDayNames read FNameOfDays write SetNameOfDays;
    property ReadOnly: Boolean read FReadOnly write SetReadOnly;
    property ShowToday: Boolean read FShowToday write SetShowToday;
    property OnDateSelected: TCalendarSelectDateEvent read FOnDateSelected write FOnDateSelected;
    property OnDateUnselected: TCalendarSelectDateEvent read FOnDateUnselected write FOnDateUnselected;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
  end;

  TWebCalendar = class(TCalendar);

implementation
end.
