{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.ContinuousScroll;

interface

uses
  Classes, Web, JS, WEBLib.Controls, WEBLib.JSON;

type
  TContinuousScrollFetchPageEvent = procedure(Sender: TObject; APageSize: Integer; APageNumber: Integer; var AURL: string) of object;
  TContinuousScrollJSONToItemEvent = procedure(Sender: TObject; AObject: TJSONObject; var AHTML: string) of object;
  TContinuousScrollObjectToArrayEvent = procedure(Sender: TObject; AObject: TJSObjectRecord; var AArray: TJSArrayRecord) of object;
  TContinuousScrollResponseToArrayEvent = procedure(Sender: TObject; AResponse: string; var AArray: TJSArrayRecord) of object;
  TContinuousScrollGetDataEvent = procedure(Sender: TObject; var AArray: TJSArrayRecord; var ALoadMoreData: Boolean) of object;
  TContinuousScrollGetItemEvent = procedure(Sender: TObject; AElementControl: TControl; AObject: TJSONObject; AIndex: Integer; AElement: TJSHTMLElementRecord) of object;
  TContinuousScrollItemFieldEvent = procedure(Sender: TObject; AIndex: Integer; AFieldName: string; var AValue: string) of object;
  TContinuousScrollPageLoadedEvent = procedure(Sender: TObject; APageNumber: Integer) of object;

  TContinuousScrollLoadType = (ltButton, ltScroll, ltNever);

  TContinuousScroll = class(TCustomControl)
  protected
    procedure BindEvents; override;
    procedure UnbindEvents; override;
    function CreateElement: TJSElement; override;
    procedure UpdateElement; override;
    function HandleScroll(aEvent : TJSUIEvent): Boolean;
    function HandleButtonClick(aEvent : TJSMouseEvent): Boolean;
    function HandleResponse(Event: TEventListenerEvent): Boolean;
    function HandleAbort(Event: TEventListenerEvent): Boolean;
    procedure ProcessResponseData(AData: string);
    procedure DoGetData(var AArray: TJSArray; var ALoadMoreData: Boolean);
    procedure DoPageLoaded(APageNumber: Integer); virtual;
    procedure DoScrollEnd; virtual;
    procedure DoLoadOnScroll; virtual;
    procedure DoFetchNextPage(APageSize, APageNumber: Integer; var AURL: string); virtual;
    procedure DoObjectToArray(AObject: TJSObject; var AArray: TJSArray); virtual;
    procedure DoResponseToArray(AResponse: string; var AArray: TJSArray); virtual;
    procedure DoJSONToItem(AObject: TJSONObject; var AHTML: string); virtual;
    procedure DoGetListItem(AElementControl: TControl; AObject: TJSONObject; ARow: Integer; AElement: TJSHTMLElement); virtual;
    procedure DoItemGetFieldValue(AIndex: Integer; AFieldName: string; var AValue: string); virtual;
    procedure ReplaceTemplateHTML(var AHTML: string; AObject: TJSONObject; AIndex: Integer);
    property ButtonElement: TJSHTMLElement read FButtonElement write FButtonElement;
    property ListEndElement: TJSHTMLElement read FListEndElement write FListEndElement;
    property LoadElement: TJSHTMLElement read FLoaderElement write FLoaderElement;
  public
    destructor Destroy; override;
    procedure CreateInitialize; override;
    procedure Clear;
    procedure FetchNextPage; virtual;
    procedure EndUpdate; override;
    function GetChildElement(AChildIndex: Integer): TJSHTMLElement;
    function GetChildElements: TJSNodeList;
  published
    property Align;
    property Anchors;
    property AutoLoadFirstPage: Boolean read FAutoLoadFirstPage write FAutoLoadFirstPage;
    property ShowHint;
    property Visible;
    property TabOrder;
    property TabStop;
    property Headers: TStringList read FHeaders write SetHeaders;
    property ButtonText: string read FButtonText write SetButtonText;
    property ListEndText: string read FListEndText write SetListEndText;
    property ElementPosition;
    property ElementFont;
    property ElementButtonClassName: TElementClassName read FElementButtonClassName write SetElementButtonClassName;
    property ElementLoadClassName: TElementClassName read FElementLoadClassName write SetElementLoadClassName;
    property ElementListEndClassName: TElementClassName read FElementListEndClassName write SetElementListEndClassName;
    property HeightPercent;
    property HeightStyle;
    property ItemTemplate: string read FItemTemplate write FItemTemplate;
    property LoadType: TContinuousScrollLoadType read FLoadType write FLoadType;
    property PageSize: Integer read FPageSize write FPageSize;
    property PageNumber: Integer read FPageNumber write FPageNumber;
    property LoadScrollPercent: Integer read FLoadScrollPercent write SetLoadScrollPercent;
    property ShowLoading: Boolean read FShowLoading write FShowLoading;
    property ShowEnd: Boolean read FShowEnd write FShowEnd;
    property WidthStyle;
    property WidthPercent;
    property OnFetchNextPage: TContinuousScrollFetchPageEvent read FOnFetchNextPage write FOnFetchNextPage;
    property OnObjectToArray: TContinuousScrollObjectToArrayEvent read FOnObjectToArray write FOnObjectToArray;
    property OnResponseToArray: TContinuousScrollResponseToArrayEvent read FOnResponseToArray write FOnResponseToArray;
    property OnJSONToItem: TContinuousScrollJSONToItemEvent read FOnJSONToItem write FOnJSONToItem;
    property OnGetListItem: TContinuousScrollGetItemEvent read FOnGetListItem write FOnGetListItem;
    property OnItemGetFieldValue: TContinuousScrollItemFieldEvent read FOnItemGetFieldValue write FOnItemGetFieldValue;
    property OnPageLoaded: TContinuousScrollPageLoadedEvent read FOnPageLoaded write FOnPageLoaded;
    property OnGetData: TContinuousScrollGetDataEvent read FOnGetData write FOnGetData;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TWebContinuousScroll = class(TContinuousScroll);

implementation
end.
