{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.FaunaDbCDS;

//{$define cdsdebug}

interface

uses
   Classes, JS, Web, SysUtils, WEBLib.CDS, jsondataset,
   DB, libFaunaDb, WebLib.REST;

type
  TFaunaDbClientDataset = class;
  TFaunaDbClientDataProxy = class;

  TFaunaDbResultEvent = procedure(success: Boolean; data: JSValue; errorName, errorMsg: String) of object;

  TFaunaDbStore = class(TObject)
  protected
  public
    constructor Create;
    procedure Init(aClientKey: String; aUsersCollectionName: String; aUsersIndexName: String);
    procedure Login(aUserName, aPassword: String; IsSignUp: Boolean; responseEvent: TFaunaDbResultEvent);
    procedure SetToken(aTokenKey: String);
    procedure GetDocs(aCollectionName: String; sortFields: TJSArray; responseEvent: TFaunaDbResultEvent);
    procedure UpdateDoc(aCollectionName: String; anId: String; data: TJSObject; responseEvent: TFaunaDbResultEvent);
    procedure DeleteDoc(aCollectionName: String; anId: String; responseEvent: TFaunaDbResultEvent);
    procedure AddDoc(aCollectionName: String; dataToWrite: TJSObject; responseEvent: TFaunaDbResultEvent);
    procedure Logout;
  end;

  TFaunaDbEntityUpdate = class(TCollectionItem)
  protected
    procedure HandleInsert(success: Boolean; data: JSValue; errorName, errorMsg: String);
    procedure HandleUpdateDelete(success: Boolean; data: JSValue; errorName, errorMsg: String);
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function Update: Boolean;
    function Insert: Boolean;
    function Delete: Boolean;
    property CustomData: JSValue read FCustomData write FCustomData;
    property Data: TJSObject read FData write FData;
  end;

  TFaunaDbEntityUpdates = class(TOwnedCollection)
  protected
    property DataProxy: TFaunaDbClientDataProxy read FDataProxy;
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TFaunaDbEntityUpdate; reintroduce;
    function Insert(Index: Integer): TFaunaDbEntityUpdate; reintroduce;
    property Items[Index: Integer]: TFaunaDbEntityUpdate read GetItems write SetItems; default;
  end;

  TFaunaDbErrorEvent = procedure(Sender: TObject; errorName, errorMsg: String) of object;

  TFaunaDbClientDataProxy = Class(TDataProxy)
 protected
    function GetDataRequest(aOptions: TLoadOptions; aAfterRequest: TDataRequestEvent; aAfterLoad: TDatasetLoadEvent) : TDataRequest; override;
    procedure HandleLogin(success: Boolean; data: JSValue; errorName, errorMsg: String);
    function DoGetData(aRequest : TDataRequest) : Boolean; override;
    procedure DoOnError(errorName, errorMsg: String);
    procedure DoOnEntityError(anEntityUpdate: TFaunaDbEntityUpdate; errorName, errorMsg: String);
    procedure DoOnEntityUpdateDelete(anEntityUpdate: TFaunaDbEntityUpdate);
    procedure DoOnEntityInsert(anEntityUpdate: TFaunaDbEntityUpdate);
    procedure HandleGetDocs(success: Boolean; data: JSValue; errorName, errorMsg: String);
    procedure ProcessUpdate(desc: TRecordUpdateDescriptor);
    procedure Close;
    // Dummy Abstract method
    function ProcessUpdateBatch(aBatch: TRecordUpdateBatch): Boolean; override;
    function GetKeyFieldName: String;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Db: TFaunaDbStore read FDb;
    property KeyFieldName: String read GetKeyFieldName;
  end;

  TFaunaDbSignupUserExistsEvent = procedure(Sender: TObject; UserName: String) of object;

  TFaunaDbClientDataset = Class(TClientDataSet)
  protected
    procedure InternalClose; override;
    Function AddToChangeList(aChange : TUpdateStatus) : TRecordUpdateDescriptor ; override;
    procedure SetActive(Value: Boolean); override;
    procedure AfterLoadDFMValues; override;
    procedure DoAfterOpen; override;
    procedure DoOnError(errorName, errorMsg: String);
    procedure UpdateStarts;
    procedure UpdateEnds;
    function IsKeyFieldValid: Boolean;
    property DataLoaded: Boolean read FDataLoaded write FDataLoaded;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Login(aUserName, aPassword: String; IsSignUp: Boolean=False);
    procedure Refresh(Force: Boolean=False); reintroduce;
    procedure AddSortFieldDef(aField: String; isAscending: Boolean);
    procedure ClearSortFieldDefs;
  published
    property ClientKey: String read FClientKey write FClientKey;
    property CollectionName: String read FCollectionName write FCollectionName;
    property KeyFieldName: String read FKeyFieldName write FKeyFieldName;
    property UsersCollectionName: String read FUsersCollectionName write FUsersCollectionName;
    property UsersIndexName: String read FUsersIndexName write FUsersIndexName;
    property OnError: TFaunaDbErrorEvent read FOnError write FOnError;
    property OnUserExists: TFaunaDbSignupUserExistsEvent read FOnUserExists write FOnUserExists;
  end;

  TWebFaunaDbClientDataset = class(TFaunaDbClientDataset);

implementation
end.
