{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright  2016                                        }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.JQGridDatabaseAdapter;

interface

uses
  Classes, WEBLib.JQGrid, WEBLib.Controls, DB;

const
  MAJ_VER = 1; // Major version nr.
  MIN_VER = 0; // Minor version nr.
  REL_VER = 0; // Release nr.
  BLD_VER = 0; // Build nr.

  // version history
  // v1.0.0.0 : first release

resourcestring
  sJQXgridDatabaseAdapterUnidirectionalDataSet = 'Unidirectional DataSet.';
  sJQXgridDatabaseAdapterNoGridAssigned = 'No grid assigned.';
  sJQXgridDatabaseAdapterNoFieldsSpecified = 'No fields specified.';
  sJQXgridDatabaseAdapterCannotAddFieldsDataSource = 'Cannot add fields, no datasource assigned.';
  sJQXgridDatabaseAdapterCannotAddFieldsDataSet = 'Cannot add fields, no DataSet specified for datasource.';
  sJQXgridDatabaseAdapterCheckBoxField = 'Cannot assign true when CheckBoxField or ProgressField is also true.';
  sJQXgridDatabaseAdapterPictureField = 'Cannot assign true when PictureField or ProgressField is also true.';
  sJQXgridDatabaseAdapterCheckPictureField = 'Cannot assign true when CheckBoxField or PictureField is also true.';

type
  TJQXGridDatabaseAdapter = class;

  TJQXGridDatabaseAdapterItemDataLink = class(TDataLink)
  protected
    procedure ActiveChanged; override;
    procedure DataSetChanged; override;
    procedure DataSetScrolled(Distance: Integer); override;
    procedure RecordChanged(Field: TField); override;
    procedure UpdateData; override;
    function Adapter: TJQXGridAdapter;
  public
    constructor Create(AAdapter: TJQXGridDatabaseAdapter);
    destructor Destroy; override;
    procedure Modified;
    procedure Reset;
  end;

  TJQXGridDatabaseAdapterColumn = class(TCollectionItem)
  protected
    function GetDisplayName: string; override;
    property AutoCreated: Boolean read FAutoCreated write FAutoCreated;
  public
    constructor Create(ACollection: TCollection); override;
    procedure Assign(Source: TPersistent); override;
    function Adapter: TJQXGridDatabaseAdapter;
    property Field: TField read GetField write SetField;
  published
    property FieldName: string read FFieldName write SetFieldName;
    property Header: string read FHeader write SetHeader;
    property CheckBoxField: Boolean read FCheckBoxField write SetCheckBoxField default false;
    property ProgressField: Boolean read FProgressField write SetProgressField default false;
    property PictureField: Boolean read FPictureField write SetPictureField default false;
    property CheckFalse: string read FCheckFalse write FCheckFalse;
    property UseLookupEditor: Boolean read FUseLookupEditor write FUseLookupEditor default True;
    property UseColumnEditor: Boolean read FUseColumnEditor write FUseColumnEditor default False;
    property CheckTrue: string read FCheckTrue write FCheckTrue;
    property HTMLTemplate: string read FHTMLTemplate write SetHTMLTemplate;
  end;

  TJQXGridDatabaseAdapterColumns = class(TOwnedCollection)
  public
    constructor Create(AAdapter: TJQXGridDatabaseAdapter);
    function HasFieldsDefined: boolean;
    function Add: TJQXGridDatabaseAdapterColumn;
    function Insert(index: Integer): TJQXGridDatabaseAdapterColumn;
    function Adapter: TJQXGridDatabaseAdapter;
    property Items[Index: Integer]: TJQXGridDatabaseAdapterColumn read GetItem write SetItem; default;
  end;

  TJQXGridDatabaseAdapterDataSetType = (adsSequenced, adsNonSequenced);
  TJQXGridDatabaseAdapterPostMode = (apmNone, apmCell, apmRow);

  TJQXGridDatabaseAdapterGetRecordCountEvent = procedure(Sender: TObject; var ARecordCount: Integer) of object;
  TJQXGridDatabaseAdapterGetHTMLTemplateDataEvent = procedure(Sender: TObject; ACol, ARow: integer; AFieldname: string; var AData: string) of object;
  TJQXGridDatabaseAdapterGetHTMLTemplateEvent = procedure(Sender: TObject; ACol, ARow: integer; var AHTMLTemplate: string; AFields: TFields) of object;

  TJQXGridDatabaseAdapterLookupItem = class
  public
    constructor Create(AIndex: Integer);
    property Index: Integer read FIndex;
  end;

  TJQXGridDatabaseAdapter = class(TJQXGridAdapter)
  protected
    procedure ClearOldPosition;
    procedure Notification(AComponent: TComponent; AOperation: TOperation); override;
    procedure RecordChanged({%H-}Field: TField);
    procedure UpdateData;
    procedure ActiveChange;
    procedure DataSetChanged;
    procedure UpdateVisibleFields;
    procedure UpdateGrid;
    procedure Scroll(Distance: Integer);
    procedure UpdateRowCount;
    procedure UpdateBounds; override;
    procedure Initialize; override;
    procedure DoAutoRemoveColumns(ARemoveDefined: Boolean); virtual;
    procedure DoGetRecordCount(var ARecordCount: Integer); virtual;
    procedure SetActiveRecord(ARow: Integer);
    procedure ExportNotification(AState: TJQXGridExportState; ARow: Integer); override;
    procedure LoadLookupList(AField: TField; AList: TStrings);
    procedure UpdateColumnHeaders; virtual;
    procedure GetCellData(ACol, ARow: Integer; ADataField: string; var ACellData: string); override;
    procedure SelectCell(ACell: TJQXGridCellRec); override;
    procedure CellEditValidateData(ACol, ARow: Integer; var CellString: String; var Allow: Boolean); override;
    procedure CellEditGetData(ACol, ARow: Integer; var CellString: String); override;
    procedure CellBeforeEdit(ACol, ARow: Integer); override;
    function CheckDatasetType: Boolean;
    function GetBufferCount: Integer;
    function GetRecordCount: Integer;
    function GetRecordNo: Integer;
    function GetLookupKey(AIndex: Integer): string;
    function HTMLDBReplace(AValue: string; ADataset: TDataSet; ACol, ARow: Integer): string;
  public
    procedure Assign(Source: TPersistent); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CheckDataSet: Boolean;
    property DataLink: TJQXGridDatabaseAdapterItemDataLink read FDataLink;
    property FieldAtColumn[ACol: Integer]: TField read GetFieldAtColumn;
    property FieldIndexAtColumn[ACol: Integer]: Integer read GetFieldIndexAtColumn;
    procedure AddAllFields;
    procedure RemoveAllFields;
    procedure RemoveAllColumns;
    procedure LoadAllDataAndDisconnect;
  published
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property Columns: TJQXGridDatabaseAdapterColumns read FColumns write SetColumns;
    property AutoCreateColumns: Boolean read FAutoCreateColumns write FAutoCreateColumns default True;
    property AutoRemoveColumns: Boolean read FAutoRemoveColumns write FAutoRemoveColumns default True;
    property OnGetRecordCount: TJQXGridDatabaseAdapterGetRecordCountEvent read FOnGetRecordCount write FOnGetRecordCount;
    property OnGetHTMLTemplateData: TJQXGridDatabaseAdapterGetHTMLTemplateDataEvent read FOnGetHTMLTemplateData write FOnGetHTMLTemplateData;
    property OnGetHTMLTemplate: TJQXGridDatabaseAdapterGetHTMLTemplateEvent read FOnGetHTMLTemplate write FOnGetHTMLTemplate;
    property DataSetType: TJQXGridDatabaseAdapterDataSetType read FDataSetType write SetDataSetType default adsSequenced;
    property DataSetTypeAuto: Boolean read FDataSetTypeAuto write FDataSetTypeAuto default True;
    property ShowBooleanFields: Boolean read FShowBooleanFields write FShowBooleanFields default True;
    property ShowPictureFields: Boolean read FShowPictureFields write FShowPictureFields default True;
    property ShowMemoFields: Boolean read FShowMemoFields write FShowMemoFields default False;
    property PostMode: TJQXGridDatabaseAdapterPostMode read FPostMode write FPostMode default apmCell;
  end;

implementation
end.
