{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}
// version history
// 1.3.5.0 : Fixed bug in FixKeyField; Removed complicated, unnecessary
//           code at the beginning of DoGetData; Removed FTableName in
//           DataProxy to be obtained from FCds; Fixed bug that didn't
//           respond to a Table Name Change, Put CheckInactive to catch
//           a property change attempt during active state.
//         : Implemented BatchUpdates and associated logic for batch
//           processing. Eliminated FUpdateCount as FDataUpdates list
//           can do the job.
// RFE: The count of FChangeList should be exposed by a property in order
//      to disallow Refresh if changes are pending. 

unit WEBLib.MyCloudCDS;


//{$define cdsdebug}

{
  For soft error testing: look at the
  comments for "soft error testing"

  Hard error testing: Any Delphi Exception will be
  hard error and should cause red alert. Try sending a
  usage error from the app, for example make the id field
  name _IDx.
}


interface

uses
   Classes, JS, Web, SysUtils, WEBLib.CDS, JSONDataSet,
   DB, WebLib.REST;

type
  TMyCloudDbClientDataset = class;
  TMyCloudDbClientDataProxy = class;

  TMyCloudDb = class(TRESTClient)
  protected
    procedure DoOnAccessToken(Sender: TObject);
    function GetAuthURL: String; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
  end;

  TMyCloudDbEntityUpdate = class(TCollectionItem)
  protected
    procedure HandleInsert(Sender: TObject; AResponse: String; var Handled: Boolean);
    procedure HandleUpdateDelete(Sender: TObject; AResponse: String; var Handled: Boolean);
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function Update: Boolean;
    function Insert: Boolean;
    function Delete: Boolean;
    property CustomData: JSValue read FCustomData write FCustomData;
    property Data: TJSObject read FData write FData;
  end;

  TMyCloudDbEntityUpdates = class(TOwnedCollection)
  protected
    property DataProxy: TMyCloudDbClientDataProxy read FDataProxy;
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TMyCloudDbEntityUpdate; reintroduce;
    function Insert(Index: Integer): TMyCloudDbEntityUpdate; reintroduce;
    property Items[Index: Integer]: TMyCloudDbEntityUpdate read GetItems write SetItems; default;
  end;

  TMyCloudDbErrorEvent = procedure(Sender: TObject; errMsg: String) of object;

  TMyCloudDbClientDataProxy = Class(TDataProxy)
 protected
    procedure GetTables;
    procedure HandleGetTables(Sender: TObject; AResponse: String; var Handled: Boolean);
    function GetDataRequest(aOptions: TLoadOptions; aAfterRequest: TDataRequestEvent; aAfterLoad: TDatasetLoadEvent) : TDataRequest; override;
    function DoGetData(aRequest : TDataRequest) : Boolean; override;
    procedure DoOnError(errMsg: String);
    procedure ProcessUpdateEnd(anIndex: Integer);
    procedure DoOnEntityError(anEntityUpdate: TMyCloudDbEntityUpdate; errMsg: String);
    procedure DoOnEntityUpdateDelete(anEntityUpdate: TMyCloudDbEntityUpdate);
    procedure DoOnEntityInsert(anEntityUpdate: TMyCloudDbEntityUpdate);
    procedure DoOnConnect(Sender: TObject);
    procedure GetEntities;
    procedure HandleGetEntities(Sender: TObject; AResponse: String; var Handled: Boolean);
    procedure ProcessUpdate(desc: TRecordUpdateDescriptor; aBatch: TRecordUpdateBatch=nil);
    procedure Close;
    function ProcessUpdateBatch(aBatch: TRecordUpdateBatch): Boolean; override;
    procedure CheckBatchComplete(aBatch: TRecordUpdateBatch);

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property TableId: String read FTableId;
    property Db: TMyCloudDb read FDb;
  end;

  TBatchUpdates = (buAuto, buManual);

  TMyCloudDbClientDataset = Class(TCustomClientDataSet)
  protected
    procedure InternalClose; override;
    Function AddToChangeList(aChange : TUpdateStatus): TRecordUpdateDescriptor ; override;
    procedure SetActive(Value: Boolean); override;
    procedure AfterLoadDFMValues; override;
    procedure DoAfterOpen; override;
    procedure DoOnError(errMsg: String);
    function GetSortSpec: String;
    procedure FixKeyField;
    function IsKeyFieldValid: Boolean;
    procedure SetAppKey(aKey: String);
    procedure SetTableName(aTableName: String);
    function GetUpdateCount: Integer;
    property DataLoaded: Boolean read FDataLoaded write FDataLoaded;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Force: Boolean=False); reintroduce;
    procedure AddSortFieldDef(aField: String; isAscending: Boolean);
    procedure ClearSortFieldDefs;
    procedure ClearTokens;
    property BatchUpdates: TBatchUpdates read FBatchUpdates write FBatchUpdates;
  published
    property AppKey: String read FAppKey write SetAppKey;
    property TableName: String read FTableName write SetTableName;
    property AppCallbackURL: String read FAppCallbackURL write FAppCallbackURL;
    property OnError: TMyCloudDbErrorEvent read FOnError write FOnError;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnFilterRecord;
    property OnNewRecord;
    property OnPostError;
    property OnUpdateRecord;
  end;

  TWebmyCloudDbClientDataset = class(TMyCloudDbClientDataset);

implementation
end.
